// *************************************************************************
// ** TestForm2:
// *************************************************************************
intrinsic TestForm2(max::RngIntElt)
{ test routine }
  a := [IntegerRing()|];

  repeat
    a1 := Random(1, max);
    a2 := -Random(1, max);

    print "====  Solving: ", a1, a2;
    b, v := IsIsotropic2(a1, a2);
    if b then
      print v;
      if (a1*v[1]*v[1] + a2*v[2]*v[2] ne 0) then print "???"; end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;


// *************************************************************************
// ** TestFormM2:
// *************************************************************************
intrinsic TestFormM2(max::RngIntElt)
{ test loop for IsIsotropic2 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 3 do
      a[i] := Random(0, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;
    m := SymmetricMatrix(a);

    print "====  Solving form: ", m;
    b, v := IsIsotropic2(m);
    if b then 
      print v;
      if ((v*m,v) ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;



// *************************************************************************
// ** TestForm3:
// *************************************************************************
intrinsic TestForm3(max::RngIntElt)
{ test loop for IsotropicVector3 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 3 do
      a[i] := Random(1, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;

    print "====  Solving form with coeffs: ", a;
    b, v := IsIsotropic3(a[1], a[2], a[3]);
    if b then 
      print v;
      if (a[1]*v[1]*v[1] + a[2]*v[2]*v[2] + a[3]*v[3]*v[3] ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;


// *************************************************************************
// ** TestFormM3:
// *************************************************************************
intrinsic TestFormM3(max::RngIntElt)
{ test loop for IsIsotropic3 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 6 do
      a[i] := Random(0, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;
    m := SymmetricMatrix(a);

    print "====  Solving form: ", m;
    b, v := IsIsotropic3(m);
    if b then 
      print v;
      if ((v*m,v) ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;



// *************************************************************************
// ** TestForm4:
// *************************************************************************
intrinsic TestForm4(max::RngIntElt)
{ test loop for IsotropicVector4 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 4 do
      a[i] := Random(1, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;

    print "====  Solving form with coeffs: ", a;
    b, v := IsIsotropic4(a[1], a[2], a[3], a[4]: Al := "Simon");
    if b then
      print v;
      if (a[1]*v[1]*v[1] + a[2]*v[2]*v[2] + a[3]*v[3]*v[3] + a[4]*v[4]*v[4] ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;



// *************************************************************************
// ** TestFormM4:
// *************************************************************************
intrinsic TestFormM4(max::RngIntElt)
{ test loop for IsIsotropic4 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 10 do
      a[i] := Random(0, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;
    m := SymmetricMatrix(a);

    print "====  Solving form: ", m;
    b, v := IsIsotropic4(m);
    if b then 
      print v;
      if ((v*m,v) ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;



// *************************************************************************
// ** TestForm5:
// *************************************************************************
intrinsic TestForm5(max::RngIntElt)
{ test loop for IsIsotropic5 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 5 do
      a[i] := Random(1, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;

    print "====  Solving form with coeffs: ", a;
    b, v := IsIsotropic5(a[1], a[2], a[3], a[4], a[5]);
    if b then
      print v;
      if (a[1]*v[1]*v[1] + a[2]*v[2]*v[2] + a[3]*v[3]*v[3] + a[4]*v[4]*v[4] + a[5]*v[5]*v[5] ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;


// *************************************************************************
// ** TestFormM5:
// *************************************************************************
intrinsic TestFormM5(max::RngIntElt)
{ test loop for IsIsotropic5 }
  a := [IntegerRing()|];

  repeat
    for i:=1 to 15 do
      a[i] := Random(0, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;
    m := SymmetricMatrix(a);

    print "====  Solving form: ", m;
    b, v := IsIsotropic5(m);
    if b then 
      print v;
      if ((v*m,v) ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;



// *************************************************************************
// ** TestForm:
// *************************************************************************
intrinsic TestForm(n::RngIntElt, max::RngIntElt)
{ test loop for IsIsotropic }
  a := [IntegerRing()|];

  repeat
    for i:=1 to n do
      a[i] := Random(1, max);
      if (Random(1,2) eq 1) then a[i] := -a[i]; end if;
    end for;

    print "====  Solving form with coeffs: ", a;
    b, v := IsIsotropic(Vector(a));
    if b then 
      print v;

      sum := 0;
      for i := 1 to n do
        sum := sum + a[i] * v[i]*v[i];
      end for;
      if (sum ne 0) then
        print "???";
      end if;
    else
      print "anisotropic";
    end if;
    print " ";

    read hocico;
  until (hocico eq "q");
end intrinsic;


